namespace dk {
	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	template <size_t D>
	Tyler<D>::Tyler (const coords& parSize, const coords& parTileSize) :
		m_size(parSize),
		m_tilesize(parTileSize)
	{
		assert(m_size.x() > 0 and m_size.y() > 0);
	}

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	template <size_t D>
	typename Tyler<D>::coords::value_type Tyler<D>::tiles_count() const {
		typename coords::value_type retval = 1;
		for (size_t d = 0; d < D; ++d) {
			retval *= m_size[d];
		}
		return retval;
	}

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	template <size_t D>
	template <typename T>
	Layer<T, D>& Tyler<D>::push_layer (typename Layer<T, D>::streamer_type&& parStreamer) {
		auto newLayer = new Layer<T, D>(m_size, m_tilesize, m_tilesize, std::move(parStreamer));
		m_layers.push_back(LayerPtr(newLayer));
		return *newLayer;
	}

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	template <size_t D>
	template <typename T>
	Layer<T, D>& Tyler<D>::push_layer (typename Layer<T, D>::streamer_type&& parStreamer, const coords& parSubdiv) {
		auto newLayer = new Layer<T, D>(m_size * parSubdiv, m_tilesize / parSubdiv, m_tilesize, std::move(parStreamer));
		m_layers.push_back(LayerPtr(newLayer));
		return *newLayer;
	}

	///--------------------------------------------------------------------------
	///--------------------------------------------------------------------------
	template <size_t D>
	void Tyler<D>::preload (const coords& parFrom, const coords& parTo) {
		for (auto& layer : m_layers) {
			layer->preload(parFrom, parTo);
		}
	}
} //namespace dk
